C**************************************************************
C     **** DDOT ... DENSE INNER PRODUCT OF TWO VECTORS ****
C**************************************************************
C
      SUBROUTINE DDOT(X,Y,K,PROD)
C
C *** PARAMETERS
      INTEGER*4 K
      DOUBLE PRECISION X(*),Y(*),PROD
C
C *** LOCAL VARIABLES
      INTEGER*4 I
C
C *** PURPOSE
C     This routine computes the scalar product
C     of two dense vectors  X and  Y.
C
C
C *** PARAMETERS DESCRIPTION
C     ON INPUT:
C     X       The first (dense) vector.
C     Y       The second (dense) vector.
C     K       Dimension of vectors  X and  Y.
C     ON OUTPUT:
C     PROD    Scalar product of vectors  X and  Y.
C
C
C *** HISTORY:
C     Written by:    Jacek Gondzio, Systems Research Institute,
C                    Polish Academy of Sciences, Newelska 6,
C                    01-447 Warsaw, Poland.
C
C     and            Dominique Tachat, LAMSADE,
C                    University of Paris Dauphine,
C                    Place du Marechal de Lattre de Tassigny,
C                    75775 Paris Cedex 16, France.
C
C     Last modified: March 24, 1992
C
C
C
C
C *** BODY OF (DDOT) ***
C
      PROD=0.
      DO 100 I=1,K
         PROD=PROD+X(I)*Y(I)
  100 CONTINUE
      RETURN
C
C *** LAST CARD OF (DDOT) ***
      END
