C***********************************************
C     ***    MYSTOP ... STOP THE PROGRAM     ***
C***********************************************
C
      SUBROUTINE MYSTOP(ISTOP)
C
C *** PARAMETERS
      INTEGER*4    ISTOP
      CHARACTER*80 BUFFER
C
C *** PARAMETER DESCRIPTION
C     ISTOP   Termination code (see also TCODE in PCPDM.F).
C             0  OPTIMAL solution found;
C             1  Primal INFEASIBLE (or dual UNBOUNDED);
C             2  Primal UNBOUNDED (or dual INFEASIBLE);
C             3  SUBOPTIMAL solution found (accuracy problems);
C             4  Excess iterations/time limit;
C             5  INFEASIBLE problem (identified by presolve analysis);
C             6  Exit due to the lack of storage for presolve history;
C             7  Exit due to the lack of storage for Cholesky factor;
C             8  Exit due to the lack of storage for LP problem data;
C             9  Exit due to the lack of storage for RWORK/IWORK;
C
C            11  THETA dropped too small.
C            12  Nonnegative variables X,S,Z or W dropped below zero.
C            13  Large error growth in the Cholesky decomposition.
C
C           >20  Exit due to fatal error.
C
C *** HISTORY:
C     Written by:    Jacek Gondzio, Systems Research Institute,
C                    Polish Academy of Sciences, Newelska 6,
C                    01-447 Warsaw, Poland.
C     Last modified: September 25, 1995
C
C *** BODY OF (MYSTOP) ***
C
      IF(ISTOP.GE.5) THEN
         WRITE(BUFFER,100) ISTOP
  100    FORMAT(1X,'MYSTOP: istop=',I3)
         CALL MYWRT(0,BUFFER)
         CALL MYWRT(99,BUFFER)
      ENDIF
      STOP
C
C *** LAST CARD OF (MYSTOP) ***
      END
