C**************************************************************
C     *** PCPDM ... HIGHER ORDER PRIMAL-DUAL METHOD         ***
C     ***           MULTIPLE CENTRALITY CORRECTORS USED     ***
C     ***           DRIVER ROUTINE OF THE  HOPDM LIBRARY    ***
C     ***           Release 2.12,   September 25, 1995      ***
C**************************************************************
C
      SUBROUTINE PCPDM(OPTTOL,TCODE,ITER,
     X LORD,MAXM,MAXN,MAXNZA,MAXNZL,M,MFINAL,N,NSTRCT,NZA,
     X IWORK,RWORK,IMAP,RMAP,LIWORK,LRWORK,IROW,RELT,
     X INTMP1,IXCHNG,ISCHNG,IMTMP1,IMTMP2,
     X RMTMP1,RMTMP2,RMTMP3,RNTMP1,RNTMP2,RNTMP3,
     X PERM,INVP,HEADER,LINKFD,LINKBK,
     X VUSED,VBNDED,C,UPBND,B,RANGES,
     X THETA,XIB,XIC,XIU,DDD,GGG,HHH,FNEW,
     X COLNRM,X,S,Y,Z,W,
     X DELTAX,DELTAS,DELTAY,DELTAZ,DELTAW,YPROX,
     X LCOEFF,LDIAG,LDSQRT,LCLPTS,LRWNBS,LLINKS,
     X RSCALE,CSCALE,STAVAR,P,Q,STAROW,RWSTAT,RWNAME,IOLOG)
C
C
C
C *** PARAMETERS
      DOUBLE PRECISION OPTTOL
      INTEGER*4 LORD,MAXM,MAXN,MAXNZA,MAXNZL,M,MFINAL,N,NSTRCT,NZA
      INTEGER*4 TCODE,ITER,LIWORK,LRWORK,IOLOG
C
      INTEGER*4 INTMP1(MAXN),IROW(MAXN)
      INTEGER*2 IXCHNG(MAXN),ISCHNG(MAXN)
      DOUBLE PRECISION RELT(MAXN)
      INTEGER*4 IMTMP1(MAXM+1),IMTMP2(MAXM+1)
      DOUBLE PRECISION RMTMP1(MAXM),RMTMP2(MAXM),RMTMP3(MAXM)
      DOUBLE PRECISION RNTMP1(MAXN),RNTMP2(MAXN),RNTMP3(MAXN)
C
C *** The following arrays can be half-length integer.
      INTEGER*2 PERM(MAXM),INVP(MAXM)
      INTEGER*2 HEADER(MAXM+1),LINKFD(MAXM+1),LINKBK(MAXM+1)
C
      LOGICAL VUSED(MAXN),VBNDED(MAXN)
      DOUBLE PRECISION C(MAXN),B(MAXM),UPBND(MAXN),RANGES(MAXM)
      DOUBLE PRECISION THETA(MAXN),XIB(MAXM),XIC(MAXN),XIU(MAXN)
      DOUBLE PRECISION DDD(MAXM),GGG(MAXN),HHH(MAXN),FNEW(MAXN)
      DOUBLE PRECISION COLNRM(MAXN)
      DOUBLE PRECISION X(MAXN),S(MAXN),Y(MAXM),Z(MAXN),W(MAXN)
      DOUBLE PRECISION DELTAX(MAXN,LORD),DELTAS(MAXN,LORD)
      DOUBLE PRECISION DELTAY(MAXM,LORD),YPROX(MAXM)
      DOUBLE PRECISION DELTAZ(MAXN,LORD),DELTAW(MAXN,LORD)
      DOUBLE PRECISION RSCALE(MAXM),CSCALE(MAXN),P(MAXM),Q(MAXM)
      INTEGER*2 STAVAR(MAXN),STAROW(MAXM),RWSTAT(MAXM)
      CHARACTER*8 RWNAME(MAXM)
C
C
C *** DATA STRUCTURES FOR CHOLESKY FACTOR
      DOUBLE PRECISION LCOEFF(MAXNZL)
      DOUBLE PRECISION LDIAG(MAXM),LDSQRT(MAXM)
      INTEGER*4 LCLPTS(MAXM+1),LLINKS(MAXNZL)
      INTEGER*2 LRWNBS(MAXNZL)
C
C
C *** HIDDEN DATA STRUCTURES
      INTEGER*4 IWORK(LIWORK),IMAP(*),RMAP(*)
      DOUBLE PRECISION RWORK(LRWORK)
C
C
C
C *** LOCAL VARIABLES
      INTEGER*4        I,ISTEP,IDIR,IRUN,IPRTRB,ITREF,IXY,IPUSH
      INTEGER*4        IALARM,IORDER,MAXORD,IFREE,RTCODE
      INTEGER*4        J,K,LX,LS,LZ,LW,LTIME,MKSQRT,M0,MOUT,NFIX,NOUT
      INTEGER*4        INFP,INFD,ELMFRQ
      DOUBLE PRECISION ERR0,ERRB0,ERRU0,ERRC0,ERRB,ERRU,ERRC
      DOUBLE PRECISION OLDGAP,DLGAP,DP,OBJ,POBJ,DOBJ,POBJ0,DOBJ0
      DOUBLE PRECISION BARR,OLDBAR,PDBARR,BARPAR,BARRMX,T,AX,AS,AZ,AW
      DOUBLE PRECISION DX,DS,DZ,DW,XTZSTW,XZSW,GPMN
      DOUBLE PRECISION ALPHA0,ALPHAP,ALPHAD
      DOUBLE PRECISION SAVEP,SAVED,STEP0,STEP1
      DOUBLE PRECISION RESX,RESY,OSCL2
      CHARACTER*100    BUFFER
C
C     Tolerances.
      DOUBLE PRECISION STEPMX,DINF,SMALLX,SMALLZ
      DOUBLE PRECISION XFIX,YFIX,PRFSBT,DLFSBT
C
C
C
C *** COMMON ARREAS
C     Cholesky factorization parameters.
      COMMON /CHFCT/   CSMALL,PIVTOL,TAU,DENSE,PIVMAX,PIVMIN,IDNSRW
      DOUBLE PRECISION CSMALL,PIVTOL,TAU,DENSE,PIVMAX,PIVMIN
      INTEGER*4        IDNSRW
C
C     Additional Cholesky fact. parameters (interface to HYBRID).
      COMMON /CHHYB/   RO,FLOPS,IREG,NZCHL,RTCD
      DOUBLE PRECISION RO,FLOPS
      INTEGER*4        IREG,NZCHL,RTCD
C
C
C
C
C *** PARAMETERS DESCRIPTION
C
C     ON INPUT:
C
C     OPTTOL  Relative optimality tolerance (default 1.D-8). 
C     TCODE   Termination code:
C             0  OPTIMAL solution found;
C             1  Primal INFEASIBLE (or dual UNBOUNDED);
C             2  Primal UNBOUNDED (or dual INFEASIBLE);
C             3  SUBOPTIMAL solution found (accuracy problems);
C             4  Excess iterations/time limit.
C     ITER    Iteration counter.
C     LORD    The highest degree of computed derivatives of x,s,y,z,w.
C     MAXM    Maximum row dimension of the LP constraint matrix.
C     MAXN    Maximum column dimension of the LP constraint matrix.
C     MAXNZA  Maximum number of nonzeros of the LP constraint matrix.
C     MAXNZL  Maximum number of nonzeros of the Cholesky factor.
C     M       Number of rows of the LP constraint matrix
C             (and the dimension of  A*Atransp).
C     N       Number of columns of the LP constraint matrix.
C     NZA     Current number of nonzeros of the LP constraint matrix.
C
C     INTMP1  Integer work array of size MAXN.
C     IXCHNG  An indicator of changes of variable X.
C     ISCHNG  An indicator of changes of variable S.
C     IMTMP1  Integer work array of size MAXM.
C     IMTMP2  Integer work array of size MAXM.
C     IROW  and  RELT are the arrays for temporary handling
C             of rows/columns of the constraint matrix. They
C             are primarily intended to handle sparse vectors
C             (in packed form) but may also be used for storing
C             dense ones.
C     RMTMP1  Double precision work array of size MAXM.
C     RMTMP2  Double precision work array of size MAXM.
C     RMTMP3  Double precision work array of size MAXM.
C     RNTMP1  Double precision work array of size MAXN.
C     RNTMP2  Double precision work array of size MAXN.
C     RNTMP3  Double precision work array of size MAXN.
C
C     PERM    Permutation resulting from the minimum degree ordering.
C     INVP    Inverse permutation.
C     HEADER  Header of the doubly linked lists.
C     LINKFD  Forward linked lists.
C     LINKBK  Backward linked lists.
C
C     VUSED   An indicator if a variable is active in the optimization
C             process:
C             .TRUE.   active variable;
C             .FALSE.  FIXED variable.
C     VBNDED  An indicator if a variable has an UPPER bound:
C             .TRUE.   UPPER bounded variable;
C             .FALSE.  UNBOUNDED variable;
C     C       Objective function coefficients.
C     UPBND   Array of upper bounds. Note that the upper bound
C             is changed when the variable has a lower bound. 
C     B       Right-hand-side of the linear program.
C     RANGES  Array of constraint ranges.
C
C     THETA   Diagonal weight matrix.
C     XIB     Violation of primal constraints, i.e.  b - A * x
C     XIC     Violation of dual   constraints, i.e.  c - At*y - z + w
C     XIU     Violation of variable bounds, i.e.     UPBND - x - s
C     DDD     Work array. It stores:
C             XIB                             (affine dir);
C             zero                            (corr., p-c algorithm).
C             zero                            (corr., pure p-d step).
C     GGG     Work array. It stores:
C             -X*Z*e                          (affine dir.);
C             BARR*e - deltaX*deltaZ*e        (corr., p-c algorithm).
C             BARR*e                          (corr., pure p-d step).
C     HHH     Work array. It stores:
C             -S*W*e                          (affine dir.);
C             BARR*e - deltaS*deltaW*e        (corr., p-c algorithm).
C             BARR*e                          (corr., pure p-d step).
C     FNEW    Work array. It stores:
C             XIC-X**(-1)*GGG+S**(-1)*HHH-S**(-1)*W*XIU (affine dir);
C             -X**(-1)*GGG+S**(-1)*HHH        (any corrector step).
C
C     COLNRM  Infinity morms of columns of  A.
C     X       Primal variables of the linear program.
C     S       Primal slack variables of the linear program.
C     Y       Dual variables of the linear program.
C     Z       Dual slack variables of the linear program.
C     W       Dual slack variables of the linear program.
C     DELTAX(*,L)  L-th component of deltaX.
C     DELTAS(*,L)  L-th component of deltaS.
C     DELTAY(*,L)  L-th component of deltaY.
C     DELTAZ(*,L)  L-th component of deltaZ.
C     DELTAW(*,L)  L-th component of deltaW.
C     YPROX   Dual proximal point.
C
C     LCOEFF  Off-diagonal nonzero coefficients of Cholesky matrix.
C     LCLPTS  Pointers to columns of the Cholesky factor.
C     LRWNBS  Row numbers of nonzeros in columns of matrix  L.
C     LLINKS  Linked lists for Cholesky factor.
C     LDIAG   Diagonal elements of Cholesky factor.
C     LDSQRT  Square roots of the diagonal elements of Cholesky factor.
C
C     RSCALE  Current row scaling factors.
C     CSCALE  Current column scaling factors.
C     STAVAR  Array of variable status:
C             0  STANDARD (nonnegative) variable i.e.: 0 <= x <= +inf;
C             1  UPPER bounded variable i.e.: 0 <= x <= u;
C             2  LOWER bounded variable i.e.: l <= x <= +inf;
C             3  both LOWER and UPPER bounded variable i.e.: l <= x <= u;
C             4  MINUS INFINITY type variable i.e.: -inf <= x <= u;
C             5  PLUS INFINITY type variable i.e.: l <= x <= +inf;
C             6  FIXED variable i.e.: x = l = u;
C             7  (or larger) PRESUMED OPTIMAL variable i.e.: x = x0;
C            -k  FREE variable. As the free variable is split into two
C                variables,  k is the number of its brother. Observe,
C                that k-th variable will also have negative status
C                that indicates the position of the original variable.
C     P       LOWER bounds on shadow prices (dual variables).
C     Q       UPPER bounds on shadow prices (dual variables).
C     STAROW  Array of row status:
C             0  row has been removed (it indicates a free row);
C             1  row has not been removed.
C     RWSTAT  Array of row types:
C             1  row type is = ;
C             2  row type is >= ;
C             3  row type is <= ;
C     RWNAME  Array of row names.
C
C     IOLOG   Output unit number where log messages are to be written.
C
C
C
C *** HIDDEN DATA STRUCTURES DESCRIPTION
C     RWORK   Real work array containing almost all real
C             LP problem data.
C     IWORK   Integer work array containing almost all integer
C             LP problem data.
C     RMAP    Map of RWORK.
C     IMAP    Map of IWORK.
C
C     Map of IWORK array:
C     IMAP(1)   Points to CLPNTS array.
C     IMAP(2)   Points to RWNMBS array.
C     IMAP(3)   Points to RWHEAD array.
C     IMAP(4)   Points to RWLINK array.
C     IMAP(5)   Points to CLNMBS array.
C     IMAP(6)   Points to LENCOL array.
C     IMAP(7)   Points to the first empty cell of IWORK array.
C
C     Map of RWORK array:
C     RMAP(1)   Points to ACOEFF array.
C     RMAP(2)   Points to COBJ array.
C     RMAP(3)   Points to RHS array.
C     RMAP(4)   Points to the first empty cell of RWORK array.
C
C
C
C *** LOCAL VARIABLES DESCRIPTION
C
C     SMALLX  The smallest acceptable value of primal variables (x or s).
C     SMALLZ  The smallest acceptable value of reduced costs (z or w).
C     DINF    Acceptable infeasibility of the primal and dual variables.
C             It is used to ensure that none of  X,S,Z,W gets zero value.
C     ERR0    ERRB+ERRU+ERRC for the initial point.
C     ERRB    max{|xib(i)|:i=1,...,m}.
C     ERRU    max{|xiu(j)|:i=1,...,n}.
C     ERRC    max{|xic(j)|:j=1,...,n}.
C     PRFSBT  Primal feasibility tolerance. As soon as the maximum of
C             infinity norms of XIB and XIU is smaller than  PRFSBT,
C             the current primal solution is presumed feasible.
C     DLFSBT  Dual feasibility tolerance. As soon as the infinity norm
C             of XIC is smaller than  DLFSBT, the current dual solution
C             is presumed feasible.
C     MKSQRT  Parameter indicating if square roots of LDIAG are to be
C             computed:
C             0  no square roots necessary;
C             1  compute square roots of diagonal matrix.
C     ELMFRQ  Elimination frequency (elimination is done once ELMFRQ
C             iterations).
C     BARR    Current barrier parameter.
C     BARPAR  The parameter used in definition of BARR.
C     POBJ    Primal objective.
C     DOBJ    Dual objective.
C     DLGAP   Duality gap.
C     ITREF   Number of steps of the iterative refinement process
C             to be done to improve the accuracy of solutions
C             with the Cholesky factorization of A*THETA*Atransp.
C     XFIX    Threshold value for fixing primal variables. As soon
C             as the primal variable is smaller than  XFIX (and the
C             appropriate dual slack variable is bounded away from
C             zero), the variable is presumed to approach a zero
C             optimal value. It is then fixed and eliminated from
C             the problem.
C     YFIX    Threshold value for eliminating LP constraints. As soon
C             as the dual variable is smaller than  YFIX (and the
C             appropriate primal slack variable is bounded away from
C             zero), the constraint is presumed to be inactive at the
C             optimum. It is then eliminated from the problem.
C     RESX    Error in the direction (part refering to deltaX).
C     RESY    Error in the direction (part refering to deltaY).
C
C
C
C
C *** SUBROUTINES CALLED:
C     LIMTIM,FACTOR,SAX(FSAX),SATY(FSATY),DABS,DBLE,MYWRT,
C     PCINIT,PCCHCK,PCDIR,PCSTEP,PCELIM.
C
C
C
C
C *** PURPOSE:
C     This is a driver routine of the  HOPDM library. 
C        It implements a Predictor-Corrector Primal-Dual logarithmic
C     barrier interior point Method. Multiple corrections of 
C     centrality are done to reduce the number of iterations
C     on difficult problems.
C
C
C
C *** REFERENCES:
C     Altman A., Gondzio J. (1993). An efficient implementation of 
C        a higher order primal-dual interior point method for large 
C        sparse linear programs, Archives of Control Sciences 2, 
C        No 1-2, pp. 23-40. 
C     Altman A., Gondzio J. (1993). HOPDM - A higher order primal-
C        dual method for large scale linear programmming, European
C        Journal of Operational Research 66 (1993) pp 158-160.
C     Gondzio J. (1992). Splitting dense columns of the constraint
C        matrix in interior point methods for large scale linear
C        programming, Optimization 24, pp. 285-297.
C     Gondzio J. (1993). Implementing Cholesky factorization for 
C        interior point methods of linear programming, Optimization 
C        27, pp. 121-140.
C     Gondzio J. (1994). Presolve analysis of linear programs prior 
C        to applying an interior point method, Technical Report 
C        No 1994.3, Department of Management Studies, University 
C        of Geneva, 102, Bd. Carl-Vogt, 1211 Geneva, Switzerland, 
C        February 1994, revised in December 1994, ORSA Journal on
C        Computing (to appear). 
C     Gondzio J. (1994). Multiple centrality corrections in a primal-
C        dual method for linear programming, Technical Report 
C        No 1994.20, Department of Management Studies, University 
C        of Geneva, 102, Bd. Carl-Vogt, 1211 Geneva, Switzerland, 
C        November 1994, revised in May 1995, Computational 
C        Optimization and Applications (to appear). 
C     Gondzio J. (1995). HOPDM (version 2.12) - A fast LP solver 
C        based on a primal-dual interior point method, European
C        Journal of Operational Research 85, pp. 221-225.
C     Gondzio J., Makowski M. (1995). Solving a class of LP problems
C        with a primal-dual logarithmic barrier method, European
C        Journal of Operational Research 80, pp. 184-192.
C     Gondzio J., Tachat D. (1994). The design and application of 
C        IPMLO - a FORTRAN library for linear optimization with 
C        interior point methods, RAIRO Recherche Operationnelle 28, 
C        No 1, pp. 37-56.
C     Lustig I., Marsten R., Shanno D.F. (1992). On implementing
C        Mehrotra's predictor-corrector interior point method for
C        linear programming, SIAM Journal on Optimization 2, 
C        No 3, pp. 435-449.
C     Mehrotra S. (1992): On the Implementation of a Primal-Dual 
C        Interior Point Method, SIAM Journal on Optimization 2, 
C        No 4, pp. 575-601.
C
C
C
C *** HISTORY:
C     Written by:    Jacek Gondzio,
C                    Systems Research Institute,
C                    Polish Academy of Sciences,
C                    Newelska 6, 01-447 Warsaw, Poland.
C     Last modified: September 25, 1995
C
C
C
C
C
C *** BODY OF (PCPDM) ***
C
C
C
C
C
C     Initialize.
C     ***********
C
C     Set up indicators of variable changes.
      DO 20 J=1,N
         IXCHNG(J)=0
         ISCHNG(J)=0
   20 CONTINUE
C
C     Define the type of diagonal in LDLt decomposition and the
C     required number of steps of the iterative refinement.
C     Initialize perturbation counter and an indicator for
C     pushing variables away from zero.
      MKSQRT=0
      ITREF=2
      IPRTRB=0
      IPUSH=0
      IRUN=0
C
C     Initialize regularizaton parameters.
      IREG=0
      RO=1.0D-10
C
C     Save the initial problem size.
      M0=M
      NOUT=0
C
C     Set up tolerances.
      DINF=  1.0D-12
      SMALLX=1.0D-14
      SMALLZ=1.0D-14
      STEPMX=1.0D0
      BARPAR=1.1
C
C     Set primal and dual feasibility tolerances.
      PRFSBT=1.0D-6
      DLFSBT=1.0D-6
C
C     Define variables for the logic of rows/cols elimination.
      ELMFRQ=200
      XFIX=1.0D-6
      YFIX=0.2D-6
      ERRB=0.D0
      ERRU=0.D0
      ERRC=0.D0
      INFP=0
      INFD=0
      XZSW=1.0D+1*DBLE(N)
C
C     Define maximum order of corrector.
      MAXORD=2
      AX=FLOPS/DBLE(2*NZCHL+12*N)
      IF(AX.GE.0.9D+1) MAXORD=3
      IF(AX.GE.3.0D+1) MAXORD=4
      IF(AX.GE.5.0D+1) MAXORD=5
      IF(AX.GE.1.0D+2) MAXORD=6
      IF(AX.GE.1.5D+2) MAXORD=7
      IF(AX.GE.2.0D+2) MAXORD=8
      IF(AX.GE.2.5D+2) MAXORD=9
      IF(AX.GE.3.0D+2) MAXORD=10
      IF(AX.GE.4.0D+2) MAXORD=11
      IF(AX.GE.5.0D+2) MAXORD=12
      IF(NZCHL.LE.5000) MAXORD=2
      WRITE(BUFFER,41)
   41 FORMAT(1X)
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
      WRITE(BUFFER,42) AX,MAXORD-2
   42 FORMAT(1X,'PCPDM:  flopsL/flopsS=',1PD8.2,'  MAXORD=',I4)
      CALL MYWRT(IOLOG,BUFFER)
      CALL MYWRT(99,BUFFER)
C
C
C
C     Go define a starting point.
      IXY=1
      CALL PCINIT(IXY,LORD,MAXM,MAXN,MAXNZA,MAXNZL,M,N,
     X IWORK,RWORK,IMAP,RMAP,LIWORK,LRWORK,IROW,RELT,
     X LCOEFF,LCLPTS,LRWNBS,LDIAG,LDSQRT,
     X VUSED,VBNDED,HEADER,LINKFD,LINKBK,
     X COLNRM,C,STAVAR,P,Q,B,UPBND,THETA,X,Y,S,Z,W,
     X DELTAX,DELTAS,DELTAY,DELTAZ,DELTAW,
     X INTMP1,RMTMP1,RMTMP2,RNTMP1,RNTMP2,IOLOG)
C
C     Initialize for proximal point algorithm.
      IREG=0
      DO 40 I=1,M
         YPROX(I)=Y(I)
   40 CONTINUE
C
C
C
C
C
C
C
C     Main loop begins here.
      ITER=0
      IFREE=0
   50 ITER=ITER+1
      ALPHA0=0.99995D0
      IF(ITER.GT.200) THEN
         WRITE(BUFFER,51)
   51    FORMAT(1X)
         CALL ERRWRT(IOLOG,BUFFER)
         WRITE(BUFFER,52)
   52    FORMAT(1X,'PCPDM:  Excess iterations limit.')
         CALL ERRWRT(IOLOG,BUFFER)
         CALL MYWRT(99,BUFFER)
         TCODE=4
         GO TO 2000
      ENDIF
C
      CALL LIMTIM(LTIME)
      IF(LTIME.NE.0) THEN
         WRITE(BUFFER,53)
   53    FORMAT(1X)
         CALL ERRWRT(IOLOG,BUFFER)
         WRITE(BUFFER,54) ITER-1
   54    FORMAT(1X,'PDPDM:  Excess time limit after ',I4,
     X    ' iterations.')
         CALL ERRWRT(IOLOG,BUFFER)
         CALL MYWRT(99,BUFFER)
         TCODE=4
         GO TO 2000
      ENDIF
C
C
C
C     Compute the duality gap and the primal and dual objectives.
C     Primal objective    POBJ=ct*x 
C     Dual   objective    DOBJ=bt*y-upbndt*w
C     Duality gap         DLGAP=POBJ-DOBJ
C     Save the best possible estimate of primal and dual objectives.
C
      POBJ=0.0D0
      DO 60 J=1,NSTRCT
         IF(VUSED(J)) POBJ=POBJ+C(J)*X(J)
   60 CONTINUE
      OBJ=POBJ
      DOBJ=0.0D0
      DO 70 I=1,M
         DOBJ=DOBJ+B(I)*Y(I)
   70 CONTINUE
      DO 80 J=1,N
         IF(VUSED(J).AND.VBNDED(J)) DOBJ=DOBJ-UPBND(J)*W(J)
   80 CONTINUE
      IF(ITER.EQ.1) THEN
         POBJ0=DABS(POBJ)+1.0D-1
         DOBJ0=DABS(DOBJ)+1.0D-1
         OLDGAP=DABS(POBJ-DOBJ)+1.0D0
C        WRITE(BUFFER,81) POBJ0,DOBJ0
C  81    FORMAT(1X,'init est: POBJ0=',1PD20.12,' DOBJ0=',1PD20.12)
C        CALL MYWRT(IOLOG,BUFFER)
      ELSE
         DLGAP=POBJ-DOBJ
         IF(DABS(DLGAP).LE.OLDGAP) THEN
            POBJ0=DABS(POBJ)+1.0D-6
            DOBJ0=DABS(DOBJ)+1.0D-6
C           WRITE(BUFFER,82) POBJ0,DOBJ0
C  82       FORMAT(1X,'obj est:  POBJ0=',1PD20.12,' DOBJ0=',1PD20.12)
C           CALL MYWRT(IOLOG,BUFFER)
            OLDGAP=DABS(DLGAP)
         ENDIF
      ENDIF
C
C
C
C     Check if the problem is UNBOUNDED/INFEASIBLE.
      DP=DABS(DLGAP)/OLDGAP
      IF(DP.GE.5.D+1) THEN
         DP=DABS(POBJ)/POBJ0
         IF(DP.GE.1.0D+4) THEN
            WRITE(BUFFER,83)
   83       FORMAT(1X,'PCPDM:  UNBOUNDED primal (or INFEASIBLE dual).')
            CALL ERRWRT(IOLOG,BUFFER)
            CALL MYWRT(99,BUFFER)
            TCODE=2
            GO TO 2000
         ENDIF
         IF(INFD.EQ.1) THEN
            WRITE(BUFFER,84)
   84       FORMAT(1X,'PCPDM:  Problem is infeasible.')
            CALL ERRWRT(IOLOG,BUFFER)
            CALL MYWRT(99,BUFFER)
            TCODE=2
            GO TO 2000
         ENDIF
         DP=DABS(DOBJ)/DOBJ0
         IF(DP.GE.1.0D+4) THEN
            WRITE(BUFFER,85)
   85       FORMAT(1X,'PCPDM:  UNBOUNDED dual (or INFEASIBLE primal).')
            CALL ERRWRT(IOLOG,BUFFER)
            CALL MYWRT(99,BUFFER)
            TCODE=1
            GO TO 2000
         ENDIF
         IF(INFP.EQ.1) THEN
            WRITE(BUFFER,86)
   86       FORMAT(1X,'PCPDM:  Primal INFEASIBLE problem.')
            CALL ERRWRT(IOLOG,BUFFER)
            CALL MYWRT(99,BUFFER)
            TCODE=1
            GO TO 2000
         ENDIF
      ENDIF
C
C
C
C     Optimality test.
C     WRITE(BUFFER,93) POBJ,DOBJ
C  93 FORMAT(1X,'PCPDM:  POBJ=',1PD20.12,' DOBJ=',1PD20.12)
C     CALL MYWRT(IOLOG,BUFFER)
      DP=DABS(DOBJ)+1.0
      DLGAP=POBJ-DOBJ
      T=DABS(DLGAP)/DP
      IF(ITER.LE.2) T=T+0.5D0
      IF(T.LE.OPTTOL) GO TO 1000
C
C
C
C
C
C     Compute  T indicating how far from the optimum we are.
      DP=DABS(POBJ)+DABS(DOBJ)+1.0
      T=DABS(DLGAP)/DP
C
C
C
C
C     Bound the variables away from zero.
C     IPUSH indicates if the last direction was accurate.
C
      CALL PUSHCP(MAXN,N,VUSED,VBNDED,STAVAR,ITER,IPUSH,
     X COLNRM,X,S,Z,W,POBJ,DOBJ,T,XZSW,DLGAP,RO,IOLOG)
C
C
C
C     Compute the residuals of the current solution.
  100 CONTINUE
C
C
C
C     Scale columns of A.
      IF(IRUN.EQ.0.AND.T.GE.1.0D-2.OR.
     X   IRUN.EQ.1.AND.T.GE.1.0D-3.OR.
     X   IRUN.GE.2.AND.T.GE.1.0D-4.OR.
     X   MOD(ITER,2).NE.0.OR.IRUN.GE.5) GO TO 150
      AX=0.0D0
      IRUN=IRUN+1
      DO 120 J=1,N
         IF(VUSED(J)) THEN
            IF(DABS(X(J)).GE.AX) AX=DABS(X(J))
         ENDIF
  120 CONTINUE
      IF(AX.LE.1.0D+4) GO TO 150
      DO 140 J=1,N
         RNTMP1(J)=1.0D0
         IF(DABS(X(J)).GE.1.0D+4) THEN
            RNTMP1(J)=1.0D+1
            X(J)=X(J)/RNTMP1(J)
            S(J)=S(J)/RNTMP1(J)
            Z(J)=Z(J)*RNTMP1(J)
            W(J)=W(J)*RNTMP1(J)
            COLNRM(J)=COLNRM(J)*RNTMP1(J)
            CSCALE(J)=CSCALE(J)/RNTMP1(J)
            RNTMP1(J)=1.0D0/RNTMP1(J)
         ENDIF
  140 CONTINUE
      OSCL2=1.0D0
      CALL SCLCOL(MAXN,MAXNZA,N,
     X IWORK(IMAP(1)),IWORK(IMAP(6)),RWORK(RMAP(1)),
     X RNTMP1,OSCL2,RWORK(RMAP(2)),UPBND,IOLOG)
  150 CONTINUE
C
C
C
C     XIB := b - A * x
C
      CALL FSAX(MAXM,MAXN,MAXNZA,X,N,XIB,M,
     X RWORK(RMAP(1)),IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(6)),
     X VUSED,IOLOG)
      DO 160 I=1,M
         XIB(I)=B(I)-XIB(I)
  160 CONTINUE
C
C     XIC := c - At*y - z + w
C     XIU := UPBND - x - s
C
      CALL FSATY(MAXM,MAXN,MAXNZA,Y,M,XIC,N,
     X RWORK(RMAP(1)),IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(6)),
     X VUSED,IOLOG)
      AS=5.0D0*XZSW/DBLE(N)
      AW=1.0D-3*T
      DO 180 J=1,N
         IF(VUSED(J)) THEN
            K=STAVAR(J)
            IF(K.LT.0) THEN
               IF(IFREE.EQ.0) THEN
                  IFREE=1
                  WRITE(BUFFER,161) 
  161             FORMAT(1X,'PCPDM:  FREE variables present.')
                  CALL MYWRT(99,BUFFER)
               ENDIF
C
C     Treat split FREE variables specially.
C     Keep their difference unchanged, but do not let them grow.
C     Keep reduced costs sufficiently bounded away from zero.
               IF(ITER/3*3.NE.ITER) GO TO 175
               IF(J.GT.-K) GO TO 175
               DP=X(-K)-X(J)
C              WRITE(BUFFER,162) -K,J,DP
C 162          FORMAT(1X,'  J1=',I6,'  J2=',I6,'  X1-X2=',1PD10.2)
C              CALL MYWRT(IOLOG,BUFFER)
               AX=5.0D0
               IF(DABS(DP).GE.1.0D+1) AX=1.0D+1
               IF(T.LE.1.0D-4) AX=AX/10.0
               IF(DP.GT.0.0) THEN
                  IF(X(J).LE.2.0D+1) GO TO 170
                  X(J)=0.01*DP+AX
                  X(-K)=X(J)+DP
               ELSE
                  IF(X(-K).LE.2.0D+1) GO TO 170
                  X(-K)=-0.01*DP+AX
                  X(J)=X(-K)-DP
               ENDIF
  170          Z(J)=AS/X(J)+AW
               Z(-K)=AS/X(-K)+AW
C              WRITE(BUFFER,171) Z(-K),Z(J),X(-K),X(J)
C 171          FORMAT(1X,'  Zj1=',1PD10.2,'  Zj2=',1PD10.2,
C    X                   '  Xj1=',1PD10.2,'  Xj2=',1PD10.2)
C              CALL MYWRT(IOLOG,BUFFER)
            ENDIF
  175       XIC(J)=C(J)-XIC(J)-Z(J)
            IF(VBNDED(J)) THEN
               XIC(J)=XIC(J)+W(J)
               XIU(J)=UPBND(J)-X(J)-S(J)
            ENDIF
         ENDIF
  180 CONTINUE
C
C
C
C     Check the feasibility of the current solution. 
C
      CALL PCCHCK(MAXM,MAXN,M,N,IOLOG,
     X 1,ERRB,ERRU,ERRC,
     X VUSED,VBNDED,XIB,XIC,XIU)
C
C
C
C     Save the initial primal residual. It will later be used
C     to determine if a sufficient progress has been made to
C     try the rows/columns elimination.
      IF(ITER.EQ.1) ERR0=ERRB+ERRU+ERRC
C
C
C
C     Eliminate the variables approaching their optimal values
C     and the constraints that are inactive at the optimum.
C     
      IF(MOD(ITER,ELMFRQ).NE.0) GO TO 200
      IF(ERRB+ERRU+ERRC.GT.ERR0*1.0D-4) GO TO 200
      IF(T.GT.1.0D-1) GO TO 200
C
C     CALL PCELIM(LORD,MAXM,MAXN,MAXNZA,MAXNZL,
C    X M,N,NSTRCT,NFIX,MOUT,
C    X IWORK,RWORK,IMAP,RMAP,LIWORK,LRWORK,IROW,RELT,
C    X LDSQRT,LCLPTS,LRWNBS,LLINKS,
C    X RWORK(RMAP(1)),IWORK(IMAP(1)),IWORK(IMAP(2)),
C    X IWORK(IMAP(3)),IWORK(IMAP(4)),IWORK(IMAP(5)),IWORK(IMAP(6)),
C    X INTMP1,IXCHNG,ISCHNG,IMTMP1,IMTMP2,RNTMP1,
C    X PERM,INVP,HEADER,LINKFD,LINKBK,
C    X PRFSBT,DLFSBT,XIB,XIU,XIC,XFIX,YFIX,
C    X X,Y,S,Z,W,DELTAX,DELTAS,DELTAY,DELTAZ,DELTAW,YPROX,
C    X VUSED,VBNDED,C,UPBND,P,Q,B,RANGES,
C    X RSCALE,CSCALE,STAVAR,STAROW,RWSTAT,RWNAME,IOLOG)
C
      NOUT=NOUT+NFIX
      WRITE(BUFFER,201) NFIX
  201 FORMAT(1X,'PCPDM:  Optimal variables   ',I13)
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
      WRITE(BUFFER,202) MOUT
  202 FORMAT(1X,'        Inactive constraints',I13)
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
C
C
C
C     Compute THETA: = (z/x + w/s)**(-1)
  200 CONTINUE
      CALL DTHETA(MAXN,N,ITER,VUSED,VBNDED,X,S,Z,W,THETA,IOLOG)
C
C
C
C     Factorize  A*THETA*Atransp matrix.
C
      DP=OPTTOL/1.0D-8
      IF(DP.GE.1.0D+2) DP=1.0D+2
      RO=RO*DP
      CALL FACTOR(MAXM,MAXN,MAXNZA,MAXNZL,M,
     X IWORK,RWORK,IMAP,RMAP,LIWORK,LRWORK,
     X INTMP1,RMTMP1,
     X HEADER,LINKFD,LINKBK,
     X THETA,STAVAR,
     X LCOEFF,LDIAG,LDSQRT,LCLPTS,LRWNBS,MKSQRT,RTCODE,IOLOG)
C
      IF(RTCODE.EQ.1) GO TO 3000
C
C
C
C     Compute the primal-dual affine scaling direction.
C
      XTZSTW=0.0D0
      DO 220 J=1,N
         IF(VUSED(J)) THEN
            XTZSTW=XTZSTW+X(J)*Z(J)
            IF(VBNDED(J)) THEN
               XTZSTW=XTZSTW+S(J)*W(J)
            ENDIF
         ENDIF
  220 CONTINUE
      PDBARR=XTZSTW/DBLE(N)
      BARR=1.0D-3*PDBARR
C
      K=0
      DO 240 J=1,N
         IF(VUSED(J)) THEN
            DP=X(J)*Z(J)
            IF(DP.GE.1.0D+1*PDBARR) THEN
               IF(DP.GE.5.0D+1*PDBARR) K=K+1
C              WRITE(BUFFER,241) J,X(J),Z(J),DP/PDBARR
C 241          FORMAT(1X,'J=',I6,'  X=',1PD10.2,'  Z=',1PD10.2,
C    X          '  ZX/AVR=',1PD10.2)
C              CALL MYWRT(IOLOG,BUFFER)
            ENDIF
            IF(VBNDED(J)) THEN
               DP=S(J)*W(J)
               IF(DP.GE.1.0D+1*PDBARR) THEN
                  IF(DP.GE.5.0D+1*PDBARR) K=K+1
C                 WRITE(BUFFER,242) J,S(J),W(J),DP/PDBARR
C 242             FORMAT(1X,'J=',I6,'   S=',1PD10.2,'  W=',1PD10.2,
C    X             '  SW/AVR=',1PD10.2)
C                 CALL MYWRT(IOLOG,BUFFER)
               ENDIF
            ENDIF
         ENDIF
  240 CONTINUE
C
C
C
      IDIR=1
      IORDER=1
      OLDBAR=0.0D0
      ALPHAP=0.0D0
      ALPHAD=0.0D0
C
      CALL PCDIR(IDIR,BARR,OLDBAR,ALPHAP,ALPHAD,SMALLX,
     X MAXM,MAXN,MAXNZA,MAXNZL,M,N,ITREF,IALARM,
     X IWORK,RWORK,IMAP,RMAP,LIWORK,LRWORK,IROW,RELT,
     X LCOEFF,LCLPTS,LRWNBS,LDIAG,LDSQRT,
     X STAVAR,VUSED,VBNDED,THETA,XIB,XIC,XIU,DDD,GGG,HHH,FNEW,
     X X,Y,S,Z,W,DELTAX,DELTAS,DELTAY,DELTAZ,DELTAW,YPROX,
     X RMTMP1,RMTMP2,RMTMP3,RNTMP1,RNTMP2,RNTMP3,
     X RESX,RESY,IOLOG)
      OLDBAR=BARR
C
      IF(IALARM.EQ.1) IPUSH=IPUSH+1
      IF(IALARM.EQ.2) GO TO 3000
      IF(RESX+RESY.GE.1.0D-6) IPUSH=1
      IF(RESX+RESY.GE.1.0D-5) IPUSH=2
      IF(RESX+RESY.GE.1.0D-3) IPUSH=3
C
C
C
C     Check if the primal-dual affine scaling direction is computed 
C     with sufficient accuracy. If not, then perturb the problem 
C     and recompute direction.
      IF(RESX+RESY.GE.1.0D-5) THEN
C
C     Here if there were errors in the affine-scaling direction.
         IPRTRB=IPRTRB+1
         IF(IPRTRB.GE.5) GO TO 3000
         WRITE(BUFFER,263)
  263    FORMAT(1X,'PCPDM:  Errors in affine-scaling direction.')
         CALL MYWRT(IOLOG,BUFFER)
         RO=1.0D-5
         IF(RESX+RESY.GE.1.0D-3) RO=1.0D-4
         IF(RESX+RESY.GE.1.0D-1) RO=1.0D-3
C
C     Bound away from zero all components of complementarity gap.
C     (This usually prevents large errors in Cholesky factors.)
         IPUSH=0
         AX=1.0D+0*T
         AZ=AX
         DO 280 J=1,N
            IF(VUSED(J)) THEN
               X(J)=X(J)+AX
               Z(J)=Z(J)+AZ
               IF(VBNDED(J)) THEN
                  S(J)=S(J)+AX
                  W(J)=W(J)+AZ
               ENDIF
            ENDIF
  280    CONTINUE
C        WRITE(BUFFER,281) AX,AZ
C 281    FORMAT(1X,'AX=',D9.3,' AZ=',D9.3,' all xszw corrected.')
C        CALL MYWRT(IOLOG,BUFFER)
         GO TO 100
      ENDIF
C
C
C
C     Determine the stepsizes for the primal-dual affine direction.
C
C     ax := min{x(j)/deltax(j,1): deltax(j,1)<0, j=1,...,n}
C     as := min{s(j)/deltas(j,1): deltas(j,1)<0, j=1,...,n}
C     az := min{z(j)/deltaz(j,1): deltaz(j,1)<0, j=1,...,n}
C     aw := min{w(j)/deltaw(j,1): deltaw(j,1)<0, j=1,...,n}
C
  300 CONTINUE
      CALL PCSTEP(N,LX,AX,X,DELTAX(1,1),IOLOG)
      CALL PCSTEP(N,LS,AS,S,DELTAS(1,1),IOLOG)
      CALL PCSTEP(N,LZ,AZ,Z,DELTAZ(1,1),IOLOG)
      CALL PCSTEP(N,LW,AW,W,DELTAW(1,1),IOLOG)
C
C     ALPHAP := min{AX,AS,STEPMX}
      ALPHAP=AX
      IF(AS.LT.ALPHAP) ALPHAP=AS
      IF(STEPMX.LT.ALPHAP) ALPHAP=STEPMX
C
C     ALPHAD := min{AZ,AW,STEPMX}
      ALPHAD=AZ
      IF(AW.LT.ALPHAD) ALPHAD=AW
      IF(STEPMX.LT.ALPHAD) ALPHAD=STEPMX
C
C *** DEBUGGING
      SAVEP=ALPHAP
      SAVED=ALPHAD
      STEP0=ALPHAP
      IF(ALPHAD.LT.STEP0) STEP0=ALPHAD
C     WRITE(BUFFER,301) AX,AS,AZ,AW
C 301 FORMAT(1X,'Affine: AX,AS,AZ,AW:  ',4D10.2)
C     CALL MYWRT(IOLOG,BUFFER)
C     WRITE(BUFFER,302) ALPHAP,ALPHAD
C 302 FORMAT(1X,'        ALPHAP,ALPHAD:  ',2D10.2)
C     CALL MYWRT(IOLOG,BUFFER)
C
C
C
C     Compute the current complementarity gap:
C     XTZSTW=Xt*Z+St*W.
C
C     Compute the minimum complementarity gap that can be achieved
C     when moving in a primal-dual affine scaling direction:
C     GPMN=(x+ALPHAP*dx)t*(z+ALPHAD*dz)+(s+ALPHAP*ds)t*(w+ALPHAD*dw).
C
C     Compute the sum of weighted lengths of  dx, ds, dz, dw: 
C     AZ=dx*theta**(-1)*dx+ds*theta**(-1)*ds+dz*theta*dz+dw*theta*dw.
C
      XTZSTW=0.0D0
      GPMN=0.0D0
      AZ=0.0D0
      DO 320 J=1,N
         IF(VUSED(J)) THEN
            DX=DELTAX(J,1)
            DZ=DELTAZ(J,1)
            XTZSTW=XTZSTW+X(J)*Z(J)
            GPMN=GPMN+(X(J)+ALPHAP*DX)*(Z(J)+ALPHAD*DZ)
            AZ=AZ+DX*DX/THETA(J)+DZ*DZ*THETA(J)
            IF(VBNDED(J)) THEN
               DS=DELTAS(J,1)
               DW=DELTAW(J,1)
               XTZSTW=XTZSTW+S(J)*W(J)
               GPMN=GPMN+(S(J)+ALPHAP*DS)*(W(J)+ALPHAD*DW)
               AZ=AZ+DS*DS/THETA(J)+DW*DW*THETA(J)
            ENDIF
         ENDIF
  320 CONTINUE
C     WRITE(BUFFER,321) ITER,XTZSTW,GPMN
C 321 FORMAT(1X,'Iter=',I6,' cmpl=',1PD10.3,' new cmpl=',1PD10.3)
C     CALL MYWRT(IOLOG,BUFFER)
C
C
C
C
C     Set the barrier parameter (Mehrotra, 1992).
C     -------------------------------------------
      IF(IORDER.GE.2) GO TO 330
      BARR=GPMN*GPMN*GPMN/(XTZSTW*XTZSTW*DBLE(N))
      BARRMX=3.33D-1
      IF(STEP0.GE.1.0D-1) BARRMX=2.0D-1
      IF(STEP0.GE.2.0D-1) BARRMX=1.0D-1
      IF(BARR.GE.BARRMX*GPMN/DBLE(N)) BARR=BARRMX*GPMN/DBLE(N)
      PDBARR=0.5D0*GPMN/DBLE(N)
      IF(AZ.GT.BARPAR*XTZSTW) THEN
         DX=ALPHAP
         IF(ALPHAD.LT.DX) DX=ALPHAD
         IF(DX.LE.2.0D-1) DX=2.0D-1
         BARR=BARR/DX
      ENDIF
C
C
C
C     Compute the corrector direction.
  330 IDIR=2
C
C
C
C     Check if the stepsizes in affine-scaling direction are 
C     sufficiently large. 
      IF(IORDER.EQ.1.AND.ALPHAP+ALPHAD.LE.5.0D-2) THEN
         WRITE(BUFFER,332)
  332    FORMAT(1X,'PCPDM:  Bad affine-scaling dir., centering added.')
         CALL MYWRT(IOLOG,BUFFER)
         CALL MYWRT(0,BUFFER)
         BARR=0.2D0*PDBARR
         IPUSH=1
         IDIR=3
      ENDIF
      IF(IORDER.GE.2) IDIR=3
  340 CONTINUE
C
      CALL PCDIR(IDIR,BARR,OLDBAR,ALPHAP,ALPHAD,SMALLX,
     X MAXM,MAXN,MAXNZA,MAXNZL,M,N,ITREF,IALARM,
     X IWORK,RWORK,IMAP,RMAP,LIWORK,LRWORK,IROW,RELT,
     X LCOEFF,LCLPTS,LRWNBS,LDIAG,LDSQRT,
     X STAVAR,VUSED,VBNDED,THETA,XIB,XIC,XIU,DDD,GGG,HHH,FNEW,
     X X,Y,S,Z,W,DELTAX,DELTAS,DELTAY,DELTAZ,DELTAW,YPROX,
     X RMTMP1,RMTMP2,RMTMP3,RNTMP1,RNTMP2,RNTMP3,
     X RESX,RESY,IOLOG)
      OLDBAR=BARR
C
      IF(IALARM.EQ.1) IPUSH=IPUSH+1
      IF(IALARM.EQ.2) GO TO 3000
      IF(RESX+RESY.GE.1.0D-6.AND.IPUSH.LE.0) IPUSH=1
      IF(RESX+RESY.GE.1.0D-5.AND.IPUSH.LE.1) IPUSH=2
      IF(RESX+RESY.GE.1.0D-3.AND.IPUSH.LE.2) IPUSH=3
C
C
C
C     Check if the predictor-corrector mechanism produces
C     sufficiently accurate direction. If not, then use pure
C     primal-dual log barrier direction.
      IF(RESX+RESY.GE.1.0D-7) THEN
         IF(IDIR.EQ.3) GO TO 350
C
C     Try pure primal-dual log barrier direction.
         WRITE(BUFFER,341)
  341    FORMAT(1X,'PCPDM:  Errors in p-c dir., try target following.')
         CALL MYWRT(IOLOG,BUFFER)
         IDIR=3
         BARR=PDBARR
         GO TO 340
C
C     Try pure primal-dual affine scaling direction.
C     Push variables away from zero in the next iteration.
  350    CONTINUE
         WRITE(BUFFER,351)
  351    FORMAT(1X,'PCPDM:  Errors in p-d dir., try affine scaling.')
         CALL MYWRT(IOLOG,BUFFER)
         ALPHA0=0.95D0
         ISTEP=1
         GO TO 800
      ENDIF
C
C
C
C     Compute the primal-dual predictor-corrector direction.
      DO 360 J=1,N
         IF(VUSED(J)) THEN
            DELTAX(J,2)=DELTAX(J,2)+DELTAX(J,1)
            DELTAZ(J,2)=DELTAZ(J,2)+DELTAZ(J,1)
            IF(VBNDED(J)) THEN
               DELTAS(J,2)=DELTAS(J,2)+DELTAS(J,1)
               DELTAW(J,2)=DELTAW(J,2)+DELTAW(J,1)
            ENDIF
         ENDIF
  360 CONTINUE
      DO 380 I=1,M
         DELTAY(I,2)=DELTAY(I,2)+DELTAY(I,1)
  380 CONTINUE
C
C
C
C     Determine the stepsizes for the primal-dual 
C     predictor-corrector direction.
C
C     ax := min{x(j)/deltax(j,2): deltax(j,2)<0, j=1,...,n}
C     as := min{s(j)/deltas(j,2): deltas(j,2)<0, j=1,...,n}
C     az := min{z(j)/deltaz(j,2): deltaz(j,2)<0, j=1,...,n}
C     aw := min{w(j)/deltaw(j,2): deltaw(j,2)<0, j=1,...,n}
C
      CALL PCSTEP(N,LX,AX,X,DELTAX(1,2),IOLOG)
      CALL PCSTEP(N,LS,AS,S,DELTAS(1,2),IOLOG)
      CALL PCSTEP(N,LZ,AZ,Z,DELTAZ(1,2),IOLOG)
      CALL PCSTEP(N,LW,AW,W,DELTAW(1,2),IOLOG)
C
C     ALPHAP := min{AX,AS,STEPMX}
      ALPHAP=AX
      IF(AS.LT.ALPHAP) ALPHAP=AS
      IF(STEPMX.LT.ALPHAP) ALPHAP=STEPMX
C
C     ALPHAD := min{AZ,AW,STEPMX}
      ALPHAD=AZ
      IF(AW.LT.ALPHAD) ALPHAD=AW
      IF(STEPMX.LT.ALPHAD) ALPHAD=STEPMX
C
C *** DEBUGGING
      STEP1=ALPHAP
      IF(ALPHAD.LT.STEP1) STEP1=ALPHAD
C     WRITE(BUFFER,381) AX,AS,AZ,AW
C 381 FORMAT(1X,'P-Corr: AX,AS,AZ,AW:  ',4D10.2)
C     CALL MYWRT(IOLOG,BUFFER)
C     WRITE(BUFFER,382) ALPHAP,ALPHAD
C 382 FORMAT(1X,'        ALPHAP,ALPHAD:  ',2D10.2)
C     CALL MYWRT(IOLOG,BUFFER)
C
C
C
C
C     Here to control computing higher order correcting terms.
C     The predictor-corrector step of order IORDER has already been
C     determined. 
      IORDER=IORDER+1
      IF(STEP1.LE.STEP0*1.01D0.AND.IORDER.GE.3) THEN
C
C     Stop correcting.
         ISTEP=1
         ALPHAP=SAVEP
         ALPHAD=SAVED
         STEP1=STEP0
         IORDER=IORDER-1
         GO TO 800
      ELSE
C
C     Save the step and try higher order corrector.
         DO 460 J=1,N
            IF(VUSED(J)) THEN
               DELTAX(J,1)=DELTAX(J,2)
               DELTAZ(J,1)=DELTAZ(J,2)
               IF(VBNDED(J)) THEN
                  DELTAS(J,1)=DELTAS(J,2)
                  DELTAW(J,1)=DELTAW(J,2)
               ENDIF
            ENDIF
  460    CONTINUE
         DO 480 I=1,M
            DELTAY(I,1)=DELTAY(I,2)
  480    CONTINUE
         IF(IORDER.GE.MAXORD) GO TO 780
         GO TO 300
      ENDIF
C
C
C
C     Reduce the stepsizes. Choose the type of step.
  780 ISTEP=2
  800 ALPHAP=ALPHA0*ALPHAP
      ALPHAD=ALPHA0*ALPHAD
C
      WRITE(BUFFER,801) ITER,IORDER-2,DLGAP,BARR,ALPHAP,ALPHAD
  801 FORMAT(1X,'PCPDM:  It=',I4,'  O=',I2,'  GP=',1PD9.2,
     X '  BRR=',1PD9.2,'  AP=',1PD8.2,'  AD=',1PD8.2)
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
      WRITE(BUFFER,803)
  803 FORMAT(1X)
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
C
C
C
C     Compute the new iterate and the complementarity gap.
C     Update the indicators of variable changes.
C
C     X := X+ALPHAP*DELTAX(ISTEP)
C     S := S+ALPHAP*DELTAS(ISTEP)
C     Y := Y+ALPHAD*DELTAY(ISTEP)
C     Z := Z+ALPHAD*DELTAZ(ISTEP)
C     W := W+ALPHAD*DELTAW(ISTEP)
C
      CALL MKSTEP(LORD,MAXM,MAXN,M,N,ISTEP,
     X VUSED,VBNDED,IXCHNG,ISCHNG,
     X X,Y,S,Z,W,YPROX,DELTAX,DELTAY,DELTAS,DELTAZ,DELTAW,
     X ALPHAP,ALPHAD,XZSW,IOLOG)
C
C
C
C     Check if the infeasibility decreased sufficiently.
      ERRB0=ERRB
      ERRU0=ERRU
      ERRC0=ERRC
C
C     XIB := b - A * x
C
      CALL FSAX(MAXM,MAXN,MAXNZA,X,N,XIB,M,
     X RWORK(RMAP(1)),IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(6)),
     X VUSED,IOLOG)
      DO 920 I=1,M
         XIB(I)=B(I)-XIB(I)
  920 CONTINUE
C
C     XIC := c - At*y - z + w
C     XIU := UPBND - x - s
C
      CALL FSATY(MAXM,MAXN,MAXNZA,Y,M,XIC,N,
     X RWORK(RMAP(1)),IWORK(IMAP(1)),IWORK(IMAP(2)),IWORK(IMAP(6)),
     X VUSED,IOLOG)
      DO 940 J=1,N
         IF(VUSED(J)) THEN
            XIC(J)=C(J)-XIC(J)-Z(J)
            IF(VBNDED(J)) THEN
               XIC(J)=XIC(J)+W(J)
               XIU(J)=UPBND(J)-X(J)-S(J)
            ENDIF
         ENDIF
  940 CONTINUE
C
      CALL PCCHCK(MAXM,MAXN,M,N,IOLOG,
     X 0,ERRB,ERRU,ERRC,
     X VUSED,VBNDED,XIB,XIC,XIU)
C
      INFP=0
      INFD=0
      IF(ERRB.GE.2.0D0*(1.0D0-ALPHAP)*ERRB0+1.0D-8) INFP=1
      IF(ERRU.GE.2.0D0*(1.0D0-ALPHAP)*ERRU0+1.0D-8) INFP=1
      IF(ERRC.GE.2.0D0*(1.0D0-ALPHAD)*ERRC0+1.0D-8) INFD=1
C     WRITE(BUFFER,941) INFP,ERRB0,ERRB 
C 941 FORMAT(1X,'INFP=',I2,'  ERRB0=',1PD16.8,' ERRB=', 1PD16.8)
C     CALL MYWRT(IOLOG,BUFFER)
C     WRITE(BUFFER,942) INFD,ERRC0,ERRC 
C 942 FORMAT(1X,'INFD=',I2,'  ERRC0=',1PD16.8,' ERRC=', 1PD16.8)
C     CALL MYWRT(IOLOG,BUFFER)
C
C
C
C     Push infeasible dual variables towards their bounds.
C     CALL DPUSH(MAXM,M,P,Q,Y,IOLOG)
C
C
C
C
C
C     End of main loop.
      GO TO 50
C
C
C
C
C
C
C     Here when optimal solution found.
 1000 TCODE=0
      WRITE(BUFFER,1001)
 1001 FORMAT(1X)
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
      WRITE(BUFFER,1002) ITER-1
 1002 FORMAT(1X,'PCPDM:  Optimal solution found after ',I4,
     X ' iterations.')
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
      CALL MYWRT(99,BUFFER)
      WRITE(BUFFER,1003) DLGAP,OBJ
 1003 FORMAT(9X,'GAP=',1PD9.2,'   (partial)OBJ=',1PD14.6)
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
C
C
C
C     Report the history of variables changes.
C     DO 1020 J=1,N
C        IF(VUSED(J)) THEN
C           WRITE(BUFFER,1021) J,STAVAR(J),IXCHNG(J),ISCHNG(J)
C1021       FORMAT(1X,'J=',I6,'   st=',I6,
C    X       '   ixchng=',I3,'   ischng=',I3)
C           CALL MYWRT(IOLOG,BUFFER)
C        ENDIF
C1020 CONTINUE
C
C
C
C     Check the feasibility of the optimal solution. 
C
C     CALL PCCHCK(MAXM,MAXN,M,N,IOLOG,
C    X 1,ERRB,ERRU,ERRC,
C    X VUSED,VBNDED,XIB,XIC,XIU)
C
C
C
C     Restore the original problem size.
 2000 CONTINUE
      MFINAL=M
      M=M0
      ITER=ITER-1
C
      RETURN
C
C
C     Here when very large errors appear in Cholesky factor.
 3000 WRITE(BUFFER,3001)
 3001 FORMAT(1X)
      CALL ERRWRT(IOLOG,BUFFER)
      DP=DABS(DOBJ)+1.0
      DLGAP=POBJ-DOBJ
      T=DABS(DLGAP)/DP
      IF(IALARM.EQ.2.OR.RTCODE.EQ.1) THEN
         WRITE(BUFFER,3011) 
 3011    FORMAT(1X,'PCPDM:  Fatal accuracy problem',
     X    ' (large errors in LLt decomposition).')
         CALL MYWRT(0,BUFFER)
         CALL MYWRT(IOLOG,BUFFER)
         CALL MYWRT(99,BUFFER)
      ENDIF
      WRITE(BUFFER,3012) ITER-1,T
 3012 FORMAT(1X,'PCPDM:  Suboptimal solution found after ',I4,
     X ' iterations (rel prec=',1PD7.1,').')
      CALL MYWRT(0,BUFFER)
      CALL MYWRT(IOLOG,BUFFER)
      CALL MYWRT(99,BUFFER)
      TCODE=3
      GO TO 2000
C
C
C *** LAST CARD OF (PCPDM) ***
      END
C***************************************************************
C     *** PUSHCP ... PUSH TOO SMALL COMPLEMENTARITY PRODUCTS ***
C***************************************************************
C
      SUBROUTINE PUSHCP(MAXN,N,VUSED,VBNDED,STAVAR,ITER,IPUSH,
     X COLNRM,X,S,Z,W,POBJ,DOBJ,T,XZSW,DLGAP,RO,IOLOG)
C
C *** PARAMETERS
      INTEGER*4 MAXN,N,ITER,IPUSH,IOLOG
      LOGICAL VUSED(MAXN),VBNDED(MAXN)
      INTEGER*2 STAVAR(MAXN)
      DOUBLE PRECISION COLNRM(MAXN),X(MAXN),S(MAXN),Z(MAXN),W(MAXN)
      DOUBLE PRECISION POBJ,DOBJ,T,XZSW,DLGAP,RO
C
C *** LOCAL VARIABLES
      DOUBLE PRECISION AX,AS,AZ,AW,DP
      INTEGER*4        J,K,LX,LS,LZ,LW
      CHARACTER*100    BUFFER
C
C
C *** BODY OF (PUSHCP) ***
C
C
C
C     Bound the variables away from zero.
C     IPUSH indicates if the last direction was accurate.
C     Use  AS to measure average complementarity gap.
C     Use  AW to measure average duality         gap.
C     Use  AX to move primal variables X and S.
C     Use  AZ to move dual   variables Z and W.
C
      IF(IPUSH.GE.1) THEN
C
C     Here if the previous direction was inaccurate.
C     Use stronger perturbation to push variables away from zero.
         WRITE(BUFFER,101)
  101    FORMAT(1X,'PUSHCP: Errors in the previous direction.')
         CALL MYWRT(IOLOG,BUFFER)
         AS=5.0D-3*XZSW/DBLE(N)
         AW=5.0D-4*DABS(DLGAP)/DBLE(N)
         IF(AS.LE.AW) AS=AW
         IF(IPUSH.GE.2) AS=2.0D0*AS
         IF(AS.GT.1.0D0) AS=1.0D0
         AX=1.0D-3*T
         IF(AX.LE.1.0D-10) AX=1.0D-10
         IF(IPUSH.GE.2) AX=1.0D+1*AX
         AZ=1.0D0*AX
         IF(AZ.GE.1.0D-5) AZ=1.0D-5
         RO=1.0D-6
         IF(IPUSH.GE.2) RO=1.0D-5
         IPUSH=0
      ELSE
C
C     Here if the previous direction was sufficiently accurate.
C     Use small perturbation to push variables away from zero.
         AS=1.0D-3*XZSW/DBLE(N)
         AW=1.0D-4*DABS(DLGAP)/DBLE(N)
         IF(AS.LE.AW) AS=AW
         IF(ITER.EQ.1.AND.AS.GT.1.0D1) AS=1.0D1
         AX=1.0D-4*T
         IF(DABS(POBJ)+DABS(DOBJ).LE.1.0D+2) AX=1.0D-1*AX
         IF(DABS(POBJ)+DABS(DOBJ).LE.1.0D+1) AX=1.0D-1*AX
         IF(AX.LE.1.0D-12) AX=1.0D-12
         AZ=1.0D0*AX
         IF(AZ.GE.1.0D-6) AZ=1.0D-6
         RO=1.0D-8
         IF(T.LE.1.0D-2) RO=1.0D-9
         IF(T.LE.1.0D-4) RO=1.0D-10
      ENDIF
C
C
C     Bound away from zero small components of complementarity gap.
C     It prevents blocking the algorithm and improves the accuracy.
C     WRITE(BUFFER,121) T,RO
C 121 FORMAT(1X,'PUSHCP: T=',1PD10.4,' penalty term, RO=',1PD10.4)
C     CALL MYWRT(IOLOG,BUFFER)
      LX=0
      LS=0
      LZ=0
      LW=0
      K=0
      DO 200 J=1,N
         IF(VUSED(J)) THEN
            DP=X(J)*Z(J)
            IF(DP.LE.AS) THEN
               K=K+1
               IF(X(J).LE.Z(J)) THEN
                  X(J)=AS/Z(J)
               ELSE
                  Z(J)=AS/X(J)
               ENDIF
C              WRITE(BUFFER,161) J,STAVAR(J),DP,X(J),Z(J)
C 161          FORMAT(1X,'J=',I6,' st=',I6,' cmpl=',D12.4,
C    X          ' X=',1PD12.4,' Z=',1PD12.4)
C              CALL MYWRT(IOLOG,BUFFER)
            ENDIF
C           IF(DP.GE.1.0D1*XZSW/DBLE(N)) THEN
C              WRITE(BUFFER,162) J,STAVAR(J),DP,X(J),Z(J)
C 162          FORMAT(1X,'J=',I6,' st=',I6,' cmpl=',D12.4,
C    X          ' X=',1PD12.4,' Z=',1PD12.4)
C              CALL MYWRT(IOLOG,BUFFER)
C           ENDIF
            IF(X(J).LE.AX) THEN
               LX=LX+1
               X(J)=X(J)+AX/COLNRM(J)
            ENDIF
            IF(Z(J).LE.AZ) THEN
               LZ=LZ+1
               Z(J)=Z(J)+AZ
            ENDIF
            IF(VBNDED(J)) THEN
               DP=S(J)*W(J)
               IF(DP.LE.AS) THEN
                  K=K+1
                  IF(S(J).LE.W(J)) THEN
                     S(J)=AS/W(J)
                  ELSE
                     W(J)=AS/S(J)
                  ENDIF
C                 WRITE(BUFFER,181) J,STAVAR(J),DP,S(J),W(J)
C 181             FORMAT(1X,'J=',I6,' st=',I6,' cmpl=',D12.4,
C    X             ' S=',1PD12.4,' W=',1PD12.4)
C                 CALL MYWRT(IOLOG,BUFFER)
               ENDIF
C              IF(DP.GE.1.0D1*XZSW/DBLE(N)) THEN
C                 WRITE(BUFFER,182) J,STAVAR(J),DP,S(J),W(J)
C 182             FORMAT(1X,'J=',I6,' st=',I6,' cmpl=',D12.4,
C    X             ' S=',1PD12.4,' W=',1PD12.4)
C                 CALL MYWRT(IOLOG,BUFFER)
C              ENDIF
               IF(S(J).LE.AX) THEN
                  LS=LS+1
                  S(J)=S(J)+AX/COLNRM(J)
               ENDIF
               IF(W(J).LE.AZ) THEN
                  LW=LW+1
                  W(J)=W(J)+AZ
               ENDIF
            ENDIF
         ENDIF
  200 CONTINUE
C     WRITE(BUFFER,201) AS,AW,LX,LS,LZ,LW,K
C 201 FORMAT(1X,'AS=',D9.3,' AW=',D9.3,' xszw=',4(I6,1X),' K=',I6)
C     CALL MYWRT(IOLOG,BUFFER)
C     WRITE(BUFFER,202) AX,AZ
C 202 FORMAT(1X,'AX=',D9.3,' AZ=',D9.3,' xszw.')
C     CALL MYWRT(IOLOG,BUFFER)
C
C
      RETURN
C
C
C *** LAST CARD OF (PUSHCP) ***
      END
C******************************************
C     ***    DTHETA ... DEFINE THETA    ***
C******************************************
C
      SUBROUTINE DTHETA(MAXN,N,ITER,
     X VUSED,VBNDED,X,S,Z,W,THETA,IOLOG)
C
C *** PARAMETERS
      INTEGER*4 MAXN,N,ITER,IOLOG
      LOGICAL VUSED(MAXN),VBNDED(MAXN)
      DOUBLE PRECISION X(MAXN),S(MAXN),Z(MAXN),W(MAXN),THETA(MAXN)
C
C *** LOCAL VARIABLES
      DOUBLE PRECISION SMALLT,DP,THMIN,THMAX
      INTEGER*4        J
      CHARACTER*100    BUFFER
C
C
C *** BODY OF (DTHETA) ***
C
C
C
      SMALLT=1.0D-20
      THMAX=0.0D0
      THMIN=1.0D+10
      DO 200 J=1,N
         IF(.NOT.VUSED(J)) GO TO 200
         IF(VBNDED(J)) THEN
C
C     Here for UPPER bounded variable.
            DP=Z(J)*S(J)+W(J)*X(J)
            IF(DP.LE.SMALLT) THEN
               WRITE(BUFFER,201) ITER,J,DP
  201          FORMAT(1X,'DTHETA: Iter=',I6,', J=',I6,' DP=',1PD10.2)
               CALL ERRWRT(IOLOG,BUFFER)
               WRITE(BUFFER,202) X(J),S(J),Z(J),W(J)
  202          FORMAT(1X,'  X(J)=',1PD10.2,'  S(J)=',1PD10.2,
     X                   '  Z(J)=',1PD10.2,'  W(J)=',1PD10.2)
               CALL ERRWRT(IOLOG,BUFFER)
               CALL MYSTOP(11)
            ENDIF
C           IF(Z(J).LE.1.0D-2.OR.W(J).LE.1.0D-2) THEN
C              WRITE(BUFFER,203) J,X(J),S(J),Z(J),W(J)
C 203          FORMAT(1X,'J=',I6,'  X=',1PD10.2,'  S=',1PD10.2,
C    X                           '  Z=',1PD10.2,'  W=',1PD10.2)
C              CALL MYWRT(IOLOG,BUFFER)
C              WRITE(BUFFER,204) J,X(J)*Z(J),S(J)*W(J)
C 204          FORMAT(1X,'J=',I6,' XZ=',1PD10.2,' SW=',1PD10.2)
C              CALL MYWRT(IOLOG,BUFFER)
C           ENDIF
            THETA(J)=S(J)*X(J)/DP
         ELSE
C
C     Here for unbounded variable.
            DP=Z(J)
            IF(DP.LE.SMALLT) THEN
               WRITE(BUFFER,206) ITER,J,Z(J)
  206          FORMAT(1X,'DTHETA: Iter=',I6,'  Z(',I6,')=',1PD10.2)
               CALL ERRWRT(IOLOG,BUFFER)
               CALL MYSTOP(11)
            ENDIF
            THETA(J)=X(J)/DP
         ENDIF
C
C     Find the largest and the smallest elements of THETA.
         IF(THETA(J).LE.THMIN) THMIN=THETA(J)
         IF(THETA(J).GE.THMAX) THMAX=THETA(J)
  200 CONTINUE
C
C
C *** DEBUGGING
C     WRITE(BUFFER,301) THMIN,THMAX
C 301 FORMAT(1X,'DTHETA: THMIN=',D9.2,'   THMAX=',D9.2)
C     CALL MYWRT(IOLOG,BUFFER)
      THMAX=1.0D+10
      DO 300 J=1,N
         IF(THETA(J).GE.THMAX) THEN
            THETA(J)=DSQRT(THMAX*THETA(J))
         ENDIF
         IF(THETA(J).GE.THMAX) THEN
            THETA(J)=DSQRT(THMAX*THETA(J))
         ENDIF
  300 CONTINUE
C
      RETURN
C
C
C *** LAST CARD OF (DTHETA) ***
      END
C*************************************************************
C     *** MKSTEP ... MAKE STEP IN THE PRIMAL & DUAL SPACES ***
C*************************************************************
C
      SUBROUTINE MKSTEP(LORD,MAXM,MAXN,M,N,ISTEP,
     X VUSED,VBNDED,IXCHNG,ISCHNG,
     X X,Y,S,Z,W,YPROX,DELTAX,DELTAY,DELTAS,DELTAZ,DELTAW,
     X ALPHAP,ALPHAD,XZSW,IOLOG)
C
C *** PARAMETERS
      INTEGER*4 LORD,MAXM,MAXN,M,N,ISTEP,IOLOG
      LOGICAL VUSED(MAXN),VBNDED(MAXN)
      INTEGER*2 IXCHNG(MAXN),ISCHNG(MAXN)
      DOUBLE PRECISION X(MAXN),Y(MAXM),S(MAXN),Z(MAXN),W(MAXN)
      DOUBLE PRECISION DELTAX(MAXN,LORD),DELTAS(MAXN,LORD)
      DOUBLE PRECISION DELTAY(MAXM,LORD),YPROX(MAXM)
      DOUBLE PRECISION DELTAZ(MAXN,LORD),DELTAW(MAXN,LORD)
      DOUBLE PRECISION ALPHAP,ALPHAD,XZSW
C
C *** LOCAL VARIABLES
      INTEGER*4        I,J
      CHARACTER*100    BUFFER
      DOUBLE PRECISION BETA
C
C
C *** BODY OF (MKSTEP) ***
C
C
C     Define BETA for proximal point.
      BETA=1.0D0
C
C
C     Make step in variables X,S,Z and W.
      XZSW=0.0D0
      DO 200 J=1,N
         If(VUSED(J)) THEN
            X(J)=X(J)+ALPHAP*DELTAX(J,ISTEP)
            Z(J)=Z(J)+ALPHAD*DELTAZ(J,ISTEP)
            XZSW=XZSW+X(J)*Z(J)
            IF(DELTAX(J,ISTEP).LE.0.0D0) THEN
               IF(IXCHNG(J).LE.0) THEN
                  IXCHNG(J)=IXCHNG(J)-1
               ELSE
                  IXCHNG(J)=0
               ENDIF
            ELSE
               IF(IXCHNG(J).GE.0) THEN
                  IXCHNG(J)=IXCHNG(J)+1
               ELSE
                  IXCHNG(J)=0
               ENDIF
            ENDIF
C           IF(X(J).LE.0D0.OR.Z(J).LE.0D0) THEN
C              WRITE(BUFFER,201) J,X(J),J,Z(J)
C 201          FORMAT(1X,'X(',I6,')=',1PD10.2,' Z(',I6,')=',1PD10.2)
C              CALL ERRWRT(IOLOG,BUFFER)
C              CALL MYSTOP(12)
C           ENDIF
            IF(VBNDED(J)) THEN
               S(J)=S(J)+ALPHAP*DELTAS(J,ISTEP)
               W(J)=W(J)+ALPHAD*DELTAW(J,ISTEP)
               XZSW=XZSW+S(J)*W(J)
               IF(DELTAS(J,ISTEP).LE.0.0D0) THEN
                  IF(ISCHNG(J).LE.0) THEN
                     ISCHNG(J)=ISCHNG(J)-1
                  ELSE
                     ISCHNG(J)=0
                  ENDIF
               ELSE
                  IF(ISCHNG(J).GE.0) THEN
                     ISCHNG(J)=ISCHNG(J)+1
                  ELSE
                     ISCHNG(J)=0
                  ENDIF
               ENDIF
C              IF(S(J).LE.0D0.OR.W(J).LE.0D0) THEN
C                 WRITE(BUFFER,202) J,S(J),J,W(J)
C 202             FORMAT(1X,'S(',I6,')=',1PD10.2,' W(',I6,')=',1PD10.2)
C                 CALL ERRWRT(IOLOG,BUFFER)
C                 CALL MYSTOP(12)
C              ENDIF
C              IF(Z(J).LE.1.0D-2.OR.W(J).LE.1.0D-2) THEN
C                 WRITE(BUFFER,211) J,X(J),S(J),Z(J),W(J)
C 211             FORMAT(1X,'J=',I6,'  X=',1PD10.2,'  S=',1PD10.2,
C    X                              '  Z=',1PD10.2,'  W=',1PD10.2)
C                 CALL MYWRT(IOLOG,BUFFER)
C                 WRITE(BUFFER,212) J,X(J)*Z(J),S(J)*W(J)
C 212             FORMAT(1X,'J=',I6,' XZ=',1PD10.2,' SW=',1PD10.2)
C                 CALL MYWRT(IOLOG,BUFFER)
C              ENDIF
            ENDIF
         ENDIF
  200 CONTINUE
C     WRITE(BUFFER,221) XZSW/DBLE(N)
C 221 FORMAT(1X,'MKSTEP: Average XZSW=',1PD10.2)
C     CALL MYWRT(IOLOG,BUFFER)
C
C
C     Make step in variables Y.
      DO 300 I=1,M
         Y(I)=Y(I)+ALPHAD*DELTAY(I,ISTEP)
  300 CONTINUE
C
C
C     Update proximal point.
      DO 400 I=1,M
         YPROX(I)=(1.0D0-BETA)*YPROX(I)+BETA*Y(I)
  400 CONTINUE
C
C
      RETURN
C
C
C *** LAST CARD OF (MKSTEP) ***
      END
C***********************************************
C     ***    DPUSH ... PUSH DUAL VARIABLES   ***
C***********************************************
C
      SUBROUTINE DPUSH(MAXM,M,P,Q,Y,IOLOG)
C
C *** PARAMETERS
      INTEGER*4 MAXM,M,IOLOG
      DOUBLE PRECISION P(MAXM),Q(MAXM),Y(MAXM)
C
C *** LOCAL VARIABLES
      INTEGER*4     I,LSMALL,LLARGE
      CHARACTER*100 BUFFER
C
C
C *** BODY OF (DPUSH) ***
C
C
C
      LSMALL=0
      LLARGE=0
      DO 100 I=1,M
         IF(Y(I).LT.P(I)) THEN
C           WRITE(BUFFER,101) I,P(I),Y(I),Q(I)
C 101       FORMAT(1X,'rw=',I6,' Pi=',D12.4,' Yi=',D12.4,' Qi=',D12.4)
C           CALL MYWRT(IOLOG,BUFFER)
            LSMALL=LSMALL+1
            Y(I)=(P(I)+Y(I))/2.0
         ENDIF
         IF(Y(I).GT.Q(I)) THEN
C           WRITE(BUFFER,102) I,P(I),Y(I),Q(I)
C 102       FORMAT(1X,'rw=',I6,' Pi=',D12.4,' Yi=',D12.4,' Qi=',D12.4)
C           CALL MYWRT(IOLOG,BUFFER)
            LLARGE=LLARGE+1
            Y(I)=(Q(I)+Y(I))/2.0
         ENDIF
  100 CONTINUE
C     WRITE(BUFFER,111) LSMALL,LLARGE
C 111 FORMAT(1X,'DPUSH:  Dual variables corrected:  Pi=',I6,' Qi=',I6)
C     CALL MYWRT(IOLOG,BUFFER)
C
      RETURN
C
C
C *** LAST CARD OF (DPUSH) ***
      END
